HDU4080 Stammering Aliens(二分 + 后缀数组)

题目

Source

http://acm.hdu.edu.cn/showproblem.php?pid=4080

Description

Dr. Ellie Arroway has established contact with an extraterrestrial civilization. However, all efforts to decode their messages have failed so far because, as luck would have it, they have stumbled upon a race of stuttering aliens! Her team has found out that, in every long enough message, the most important words appear repeated a certain number of times as a sequence of consecutive characters, even in the middle of other words. Furthermore, sometimes they use contractions in an obscure manner. For example, if they need to say bab twice, they might just send the message babab, which has been abbreviated because the second b of the first word can be reused as the first b of the second one.
Thus, the message contains possibly overlapping repetitions of the same words over and over again. As a result, Ellie turns to you, S.R. Hadden, for help in identifying the gist of the message.
Given an integer m, and a string s, representing the message, your task is to find the longest substring of s that appears at least m times. For example, in the message baaaababababbababbab, the length-5 word babab is contained 3 times, namely at positions 5, 7 and 12 (where indices start at zero). No substring appearing 3 or more times is longer (see the first example from the sample input). On the other hand, no substring appears 11 times or more (see example 2). In case there are several solutions, the substring with the rightmost occurrence is preferred (see example 3).

Input

The input contains several test cases. Each test case consists of a line with an integer m (m >= 1), the minimum number of repetitions, followed by a line containing a string s of length between m and 40 000, inclusive. All characters in s are lowercase characters from "a" to "z". The last test case is denoted by m = 0 and must not be processed.

Output

Print one line of output for each test case. If there is no solution, output none; otherwise, print two integers in a line, separated by a space. The first integer denotes the maximum length of a substring appearing at least m times; the second integer gives the rightmost starting position of this substring.

Sample Input

3
baaaababababbababbab
11
baaaababababbababbab
3
cccccc
0

Sample Output

5 12
none
4 2

分析

题目大概说给一个字符串,求出现至少m的子串的最长长度以及出现在最右边的位置。

经典的后缀数组题目吧,二分长度,height分组判定长度是否成立。。

代码

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define MAXN 44444
 
int wa[MAXN],wb[MAXN],wv[MAXN],ws[MAXN];
int cmp(int *r,int a,int b,int l){
    return r[a]==r[b] && r[a+l]==r[b+l];
}
int sa[MAXN],rnk[MAXN],height[MAXN];
void SA(int *r,int n,int m){
    int *x=wa,*y=wb;
 
    for(int i=0; i<m; ++i) ws[i]=0;
    for(int i=0; i<n; ++i) ++ws[x[i]=r[i]];
    for(int i=1; i<m; ++i) ws[i]+=ws[i-1];
    for(int i=n-1; i>=0; --i) sa[--ws[x[i]]]=i;
 
    int p=1;
    for(int j=1; p<n; j<<=1,m=p){
        p=0;
        for(int i=n-j; i<n; ++i) y[p++]=i;
        for(int i=0; i<n; ++i) if(sa[i]>=j) y[p++]=sa[i]-j;
        for(int i=0; i<n; ++i) wv[i]=x[y[i]];
        for(int i=0; i<m; ++i) ws[i]=0;
        for(int i=0; i<n; ++i) ++ws[wv[i]];
        for(int i=1; i<m; ++i) ws[i]+=ws[i-1];
        for(int i=n-1; i>=0; --i) sa[--ws[wv[i]]]=y[i];
        swap(x,y); x[sa[0]]=0; p=1;
        for(int i=1; i<n; ++i) x[sa[i]]=cmp(y,sa[i-1],sa[i],j)?p-1:p++;
    }
 
    for(int i=1; i<n; ++i) rnk[sa[i]]=i;
    int k=0;
    for(int i=0; i<n-1; height[rnk[i++]]=k){
        if(k) --k;
        for(int j=sa[rnk[i]-1]; r[i+k]==r[j+k]; ++k);
    }
}

char str[MAXN];
int n,m,a[MAXN];

bool isOK(int len){
	int left=-1,right,mx=0;
	for(int i=2; i<=n; ++i){
		if(height[i]>=len){
			if(left==-1) left=i-1;
			right=i;
		}else{
			left=-1;
		}
		if(left!=-1) mx=max(mx,right-left+1);
	}
	return mx>=m;
}

int getRightMost(int len){
	int left=-1,right,mx=0,tmp=0;
	for(int i=2; i<=n; ++i){
		if(height[i]>=len){
			if(left==-1) left=i-1;
			right=i;
			tmp=max(tmp,max(sa[i-1],sa[i]));
		}else{
			left=-1;
			tmp=0;
		}
		if(left!=-1){
			if(right-left+1>=m) mx=max(mx,tmp);
		}
	}
	return mx;
}

int main(){
	while(scanf("%d",&m)==1 && m){
		scanf("%s",str);
		n=strlen(str);
		if(m==1){
			printf("%d %d
",n,0);
			continue;
		}
		for(int i=0; i<n; ++i){
			a[i]=str[i]-'a'+1;
		}
		a[n]=0;
		SA(a,n+1,28);
		int l=0,r=MAXN;
		while(l<r){
			int mid=l+r+1>>1;
			if(isOK(mid)) l=mid;
			else r=mid-1;
		}
		if(l==0){
			puts("none");
			continue;
		}
		printf("%d %d
",l,getRightMost(l));
	}
	return 0;
}
原文地址:https://www.cnblogs.com/WABoss/p/5830269.html